%
% e-Informatyka.pl TeX styles definitions to be used by the following journals:
% 1) e-Informatica Software Engineering Journal (ISEJ)
% 2) Scientific Papers of the Institute of Applied Informatics of Wroclaw University of Technology or SPSE (Scientific Papers on Software Engineering) for short.
% Micha� Stochmia�ek misto@e-informatyka.pl
% Lech Madeyski lma@e-informatyka.pl
% Piotr Przybyl ppr@e-informatyka.pl
% (C) 2005-2007 e-Informatyka.pl

\ProvidesClass{einformatyka}[2009/09/10]
\NeedsTeXFormat{LaTeX2e}

\PassOptionsToClass{11pt}{mwart}
\PassOptionsToClass{twoside}{mwart}
\PassOptionsToClass{noindentfirst,a4paper}{mwart}
\ProcessOptions
\LoadClass{mwart}
%\RequirePackage[width=165mm,height=25cm,twoside,includeheadfoot]{geometry}
\usepackage[width=165mm,height=25cm,left=25mm,top=20mm,twoside,includeheadfoot]{geometry}
\setlength\columnsep{5mm}
\topsep0pt
\RequirePackage{fancyhdr}
\RequirePackage[grid]{multicol}
% \RequirePackage[verbose=true]{microtype}
\RequirePackage{amsmath}
\allowdisplaybreaks[4]
\RequirePackage{url}
\urlstyle{rm}

%% Jesteśmy w Europie więc 
\frenchspacing

%%%%%%%%%%%%
%% Wzory
\renewcommand\normalsize{%
   \@setfontsize\normalsize\@xipt{13.6}%
%    \abovedisplayskip 11\p@ %\@plus3\p@ \@minus6\p@
%   \abovedisplayskip \z@ %\@plus3\p@ \@minus6\p@
   \abovedisplayskip .3\baselineskip
   \abovedisplayshortskip \z@
%   \belowdisplayshortskip 6.5\p@ %\@plus3.5\p@ \@minus3\p@
%   \belowdisplayshortskip \z@ %\@plus3.5\p@ \@minus3\p@
   \belowdisplayshortskip \z@
   \belowdisplayskip .3\baselineskip
   }

%% Rozdzialy
\SetSectionFormatting{section}
        {2\baselineskip}
        {\FormatHangHeading{\large}}
        {\baselineskip}
\SetSectionFormatting{subsection}
        {1.33\baselineskip}
        {\FormatHangHeading{}}
        {0.67\baselineskip}
\SetSectionFormatting{subsubsection}
        {1.33\baselineskip}
        {\FormatHangHeading{\normalfont}}
        {0.67\baselineskip}
%%%%%%%%%%%
%% Rozne rozmiary -- ilustracje
\setlength\floatsep    {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\textfloatsep{0pt}
\setlength\intextsep   {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\dblfloatsep    {12\p@ \@plus 2\p@ \@minus 2\p@}
\setlength\dbltextfloatsep{20\p@ \@plus 2\p@ \@minus 4\p@}
\setlength\@fptop{0\p@ \@plus 1fil}
\setlength\@fpsep{8\p@ \@plus 2fil}
\setlength\@fpbot{0\p@ \@plus 1fil}
\setlength\@dblfptop{0\p@ \@plus 1fil}
\setlength\@dblfpsep{8\p@ \@plus 2fil}
\setlength\@dblfpbot{0\p@ \@plus 1fil}
%%
\setlength{\medskipamount}{.5\baselineskip}
%%
\setlength\abovecaptionskip{.5\baselineskip}
\setlength\belowcaptionskip{.5\baselineskip} % Powinno być 1.5, ale na razie rezygnujemy
%%
\setcounter{topnumber}{3}
\renewcommand\topfraction{.85}
\setcounter{bottomnumber}{1}
\renewcommand\bottomfraction{.5}
\setcounter{totalnumber}{3}
\renewcommand\textfraction{.2}
\renewcommand\floatpagefraction{.5}
\setcounter{dbltopnumber}{2}
\renewcommand\dbltopfraction{.7}
\renewcommand\dblfloatpagefraction{.5}
%%
%% Listy
\renewcommand\labelitemi{\textendash}
\renewcommand\labelitemii{\textendash}
\renewcommand\labelitemiii{\textendash}
%%
%% Srodowiska
\renewenvironment{quote}
               {\list{}{\partopsep\topsep \topsep\z@\rightmargin\leftmargin}%
                \item\relax}
               {\endlist}
%%

%% theorem (newtheorem)
\def\@opargbegintheorem#1#2#3{\trivlist
      \item[\hskip \labelsep{\bfseries #1\ #2\ (#3).}]\itshape}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\renewenvironment{thebibliography}[1]
     {\subsection*{\refname}%   %References smaller
      \@mkboth{\MakeUppercase\refname}{\MakeUppercase\refname}%
      \small\list{\@biblabel{\@arabic\c@enumiv}}% %makes all list of references items small
           {\settowidth\labelwidth{\@biblabel{#1}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
      \sfcode`\.\@m}
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}

\def\fnum@figure{\centering\small\figurename\nobreakspace\thefigure}
\def\fnum@table{\centering\small\tablename\nobreakspace\thetable}

\renewcommand\footnoterule{%
  \kern-3\p@
  \vspace{0.5em}
  \hrule\@width.4\columnwidth
  \kern2.6\p@}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% \setlength\textwidth{150mm}
% \setlength\textwidth{165mm}
% \setlength\marginparwidth{0mm}
% \setlength\marginparsep{0mm}
% \setlength\oddsidemargin{10mm}
% \setlength\evensidemargin{0mm}

%\thispagestyle{empty}
\def\ps@copyright{\def\@oddhead{\scriptsize{{e-Informatica Software Engineering Journal, Volume 3, Issue 1, 2009}\hfill %\thepage
}}}  %\ttfamily http://www.e-informatyka.pl/journal/e-Informatica}}


\thispagestyle{copyright}
\pagestyle{fancy}

% potrzebne dla komendy \collect@body

\newcommand{\titlesize}{%
  \@setfontsize\titlesize{19}{23}}

\def\title#1{\lineskip 0.75em\xdef\@etitle{#1}}
% \def\title#1{\xdef\@etitle{#1}}
\def\subtitle#1{\xdef\@esubtitle{#1}}
%% ShortTitle, ShortAuthorsHead -- do żywej paginy: hack by WM
\def\shorttitle#1{\xdef\@eshorttitle{#1}}
\def\shortauthorshead#1{\xdef\@eshortauthorshead{#1}}
\def\alteemails#1{\xdef\@alteemails{#1}}
%%
\def\keywordset#1{\xdef\@ekeywordset{#1}}

\def\firstname#1{\xdef\@efirstname{#1}}
\def\surname#1{\xdef\@esurname{#1}}
\def\email#1{\xdef\@eemail{#1}}
\def\orgname#1{\xdef\@eorgname{#1}}
\def\orgdiv#1{\xdef\@eorgdiv{#1}}

\newenvironment{authorgroup}{}{
 \gdef\@edots\undefined
 \gdef\@eauthors\undefined
 \gdef\@eorgs\undefined
 \gdef\@eemails\undefined
}

\renewenvironment{author}{}{
 % polacz nazwe organizacji z nazwa jej oddzialu
 \xdef\@etmporg{%
   \ifx\@eorgdiv\undefined\else
     \@eorgdiv
   \fi
   \ifx\@eorgdiv\undefined\else\ifx\@eorgname\undefined\else,\ \fi\fi
   \ifx\@eorgname\undefined\else
     \@eorgname
   \fi
 }

 \ifx\@elastorg\undefined
  \xdef\@elastorg{empty}
 \fi

 % czy podany orgdiv lub orgname
 \ifx\@eorgdiv\undefined
   \ifx\@eorgname\undefined
   \else
     \xdef\@ethisorg{\@etmporg}
   \fi
 \else
   \xdef\@ethisorg{\@etmporg}
 \fi

 % jezeli organizacja nie podana to nie zwiekszamy gwiazdek
 \ifx\@ethisorg\undefined\else
   % jezeli poprzednia organizacja jest identyczna, to nie zwiekszaj gwiazdek
   \ifx\@ethisorg\@elastorg\else
     \xdef\@edots{\ifx\@edots\undefined\else\@edots\fi*}
   \fi
 \fi

 % dodaj autora do listy autorow
 \ifx\@efirstname\undefined
   \ClassError{einformatyka}{Author firstname not defined!}{}
  \else
   \ifx\@esurname\undefined
     \ClassError{einformatyka}{Author surname not defined!}{}
   \else
     \xdef\@eauthors{%
      \ifx\@eauthors\undefined\else
        \@eauthors,\
      \fi
      \ifx\@efirstname\undefined\else
        \@efirstname\
      \fi

      \ifx\@esurname\undefined\else
        \@esurname
      \fi

      \ifx\@ethisorg\undefined\else
        $^{\@edots}$\ignorespaces
      \fi
    }
  \fi
 \fi

 % dodaj autora do listy autorow na potrzeby naglowka
 \ifx\@efirstname\undefined
   \ClassError{einformatyka}{Author firstname not defined!}{}
  \else
   \ifx\@esurname\undefined
     \ClassError{einformatyka}{Author surname not defined!}{}
   \else
     \xdef\@eauthorshead{%
      \ifx\@eauthorshead\undefined\else
        \@eauthorshead,\
      \fi
      \ifx\@efirstname\undefined\else
        \@efirstname\
      \fi

      \ifx\@esurname\undefined\else
        \@esurname
      \fi
    }
  \fi
 \fi

 % dodaj organizacje do listy organizacji (jezeli niepusta i nieidentyczna z ostatnia)
 \ifx\@ethisorg\undefined\else
   \ifx\@ethisorg\@elastorg\else
    \xdef\@eorgs{
      \ifx\@eorgs\undefined\else \@eorgs \protect\break \fi
        $^{\@edots}$\@ethisorg %italics with asterisks
     }
   \fi
 \fi

 % dodaj maila do listy maili
 \ifx\@eemail\undefined\else
  \xdef\@eemails{\ifx\@eemails\undefined\else\@eemails,\ \fi % comma afrer eemails
    \@eemail
  }
 \fi

 \ifx\@ethisorg\undefined\else
   \xdef\@elastorg{\@ethisorg}
 \fi

 \gdef\@efirstname\undefined
 \gdef\@esurname\undefined
 \gdef\@eemail\undefined
 \gdef\@eorgname\undefined
 \gdef\@eorgdiv\undefined
 \gdef\@ethisorg\undefined
}

\def\@storeabstract#1{\gdef\@eabstract{#1}}
\renewenvironment{abstract}[1][-]{\collect@body\@storeabstract}{}

\def\@storeepigraph#1{\gdef\@eepigraph{#1}}
\newenvironment{epigraph}{\collect@body\@storeepigraph}{}

\newenvironment{articleinfo}
{%
 \begin{center}%
}{%
%
 \ifx\@etitle\undefined
  \ClassError{einformatyka}{Title not defined!}{}
 \else
  {\vspace*{13mm}\bf\titlesize \@etitle\par}
 \fi
%
 \ifx\@esubtitle\undefined\else
  \vspace{2mm} {\large \@esubtitle}
 \fi
%
 \vspace{7mm}
%
 \ifx\@eauthors\undefined
   \ClassError{einformatyka}{Authors not defined!}{}
 \else
   {\large \@eauthors\par }
 \fi
%
 \ifx\@eorgs\undefined\else
  \vspace{1mm} {\small\it \@eorgs\par} %removed it
 \fi
%
 \ifx\@eemails\undefined\else
  \vspace{1mm} {\small\tt \ifx\@alteemails\undefined\@eemails\else\@alteemails\fi\par}
 \fi
%
 \ifx\@eepigraph\undefined\else
  \vspace{5mm}
  \begin{minipage}{0.9\textwidth}
   \begin{flushright}
    \small\it \@eepigraph
   \end{flushright}
  \end{minipage}
 \fi
%
 \ifx\@eabstract\undefined
   \ClassError{einformatyka}{Abstract not defined!}{}
 \else
  \vspace{5mm} {\centering\bf Abstract} %centering
%  \vspace{6pt}
  \begin{minipage}{0.9\textwidth}\small
    \@eabstract
  \end{minipage} \vspace{1mm}
 \fi
%
% \ifx\@ekeywordset\undefined\else
%  \vspace{2mm}
%  \begin{minipage}{0.9\textwidth}    {\bf Keywords:} \@ekeywordset
%  \end{minipage}
% \fi
%
 \vspace{5mm}
%
 \end{center}

 \lfoot{}\cfoot{}\rfoot{}
 \lhead[\thepage]{\it\footnotesize%
  \ifx\@eshorttitle\undefined\@etitle\else\@eshorttitle\fi}
 \rhead[{\footnotesize\ifx\@eshortauthorshead\undefined\@eauthorshead\else\@eshortauthorshead\fi}]{\thepage}

 \gdef\@earticleinfo
}

\AtEndDocument{
 \ifx\@earticleinfo\undefined
   \ClassError{einformatyka}{ArticleInfo not defined!}{}
 \fi
}
% \widowpenalty=10000
% \clubpenalty=10000
%% likwidujemy wdowy i sieroty...
\widowpenalty=10000
\clubpenalty=10000
% \raggedbottom
